/*
 *  blob.cpp
 *  Ruby_HW11Blobs2
 *
 *  Created by Matthew Ruby on 11/16/10.
 *  Copyright 2010. All rights reserved.
 *
 */

#include "blob.h"


//------------------------------------------------------------------
void blob::setup() {
	
	for (int i = 0; i < 80; i++){
		particle myParticle;
		
		float x = 400 + 40 * cos ( (i / 80.0) * TWO_PI);
		float y = 400 + 40 * sin ( (i / 80.0) * TWO_PI);
		
		myParticle.setInitialCondition(x,y ,0,0);
		particles.push_back(myParticle);
	}
	
	// change this to
	// for (int i = 0; i < 10; i++){
	// to see a chain
	
	for (int i = 0; i < particles.size(); i++){
		spring mySpring;
		mySpring.distance		= 4;
		mySpring.springiness	= 0.2f;
		mySpring.particleA = & (particles[i  ]);
		mySpring.particleB = & (particles[(i+1) % particles.size()]);
		springs.push_back(mySpring);
	}
}



//------------------------------------------------------------------
void blob::update() {
	// on every frame 
	// we reset the forces
	// add in any forces on the particle
	// perfom damping and
	// then update
	avgParticle.x = 0;
	avgParticle.y = 0;
	
	for (int i = 0; i < particles.size(); i++){
		particles[i].resetForce();
		particles[i].addForce(0.0,0.1);
		avgParticle.x += particles[i].pos.x;
		avgParticle.y += particles[i].pos.y;
    }
	
	avgParticle.x = avgParticle.x/particles.size();
	avgParticle.y = avgParticle.y/particles.size();
	
	for (int i = 0; i < particles.size(); i++){
		
		particles[i].addRepulsionForce(avgParticle.x, avgParticle.y, 300,sin(ofGetElapsedTimef()*0.5));
		
		for (int j = 0; j < i; j++){
			particles[i].addRepulsionForce(particles[j], 50, 0.9);
		}
	}
	
	for (int i = 0; i < springs.size(); i++){
		springs[i].update();
	}
	
	
	for (int i = 0; i < particles.size(); i++){
		particles[i].bounceOffWalls();
		particles[i].addDampingForce();
		particles[i].update();
	}
}



//------------------------------------------------------------------
void blob::draw() {
	ofBeginShape();
	for (int i = 0; i < particles.size(); i++){
		//		particles[i].draw();
		ofCurveVertex(particles[i].pos.x, particles[i].pos.y);
	}
	ofEndShape(true);
	
	/*	
	 for (int i = 0; i < springs.size(); i++){
	 //	springs[i].draw();
	 
	 }
	 */
}

